=== debian/changelog ===
cgal (5.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Change Build-Depends/Depends: from libgmp10-dev to libgmp-dev.
    Thanks to Bas Couwenberg (Closes: #946403).
  * Add Depends: qtbase5-dev, libqt5opengl5-dev, libqt5svg5-dev to
    libcgal-qt5-dev (Closes: #949800).
  * Use debhelper compat version 12 (no changes needed).
  * Update Standards-Version to 4.5.0 (no changes needed).
  * Fix bogus lintian warning incorrect-packaging-filename for
    debian/NEWS.Debian (there was special code to take care of that).

 -- Joachim Reichel <reichel@debian.org>  Mon, 27 Jan 2020 22:43:30 +0100
